---
title: Date.now()
slug: Web/JavaScript/Reference/Global_Objects/Date/now
tags:
  - Date
  - JavaScript
  - Method
  - Reference
  - Time
  - polyfill
---
<div>{{JSRef}}</div>

<p>The static <strong><code>Date.now()</code></strong> method returns the number of milliseconds elapsed since January 1, 1970 00:00:00 UTC.</p>

<div>{{EmbedInteractiveExample("pages/js/date-now.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <var>timeInMs</var> = Date.now();</pre>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Number")}} representing the milliseconds elapsed since the UNIX epoch.</p>

<h2 id="Polyfill">Polyfill</h2>

<p>This method was standardized in ECMA-262 5<sup>th</sup> edition. Engines which have not been updated to support this method can work around the absence of this method using the following shim:</p>

<pre class="brush: js notranslate">if (!Date.now) {
  Date.now = function now() {
    return new Date().getTime();
  };
}
</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Reduced_time_precision">Reduced time precision</h3>

<p>To offer protection against timing attacks and fingerprinting, the precision of <code>Date.now()</code> might get rounded depending on browser settings.<br>
 In Firefox, the <code>privacy.reduceTimerPrecision</code>  preference is enabled by default and defaults to 20µs in Firefox 59; in 60 it will be 2ms.</p>

<pre class="brush: js notranslate">// reduced time precision (2ms) in Firefox 60
Date.now()
// 1519211809934
// 1519211810362
// 1519211811670
// ...

// reduced time precision with `privacy.resistFingerprinting` enabled
Date.now();
// 1519129853500
// 1519129858900
// 1519129864400
// ...
</pre>

<p>In Firefox, you can also enable <code>privacy.resistFingerprinting</code>, the precision will be 100ms or the value of <code>privacy.resistFingerprinting.reduceTimerPrecision.microseconds</code>, whichever is larger.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-date.now', 'Date.now')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("javascript.builtins.Date.now")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("Performance.now()")}} — provides timestamps with sub-millisecond resolution for use in measuring web page performance</li>
 <li>{{domxref("console.time()")}} / {{domxref("console.timeEnd()")}}</li>
</ul>
